/*
 * SamygoPVR loader.
 */

#include <stdio.h>
#include <dlfcn.h>

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	char s[256];
	unsigned *handle;
	int (*ex_mod_init)(const char *);

	/*
     * Just load "mod.so" with RTLD_NODELETE and call the library
     * init function mod_init(). All the work should be done by
     * mod_init().
     */

	snprintf(s, sizeof(s), "%s%s", path, "mod.so");
	if ((handle = dlopen(s, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL)
		return (0);

	ex_mod_init = dlsym(handle, "mod_init");
	dlclose(handle);
	if (ex_mod_init == NULL || ex_mod_init(path) < 0)
		return (0);

	return 1;
}
