#include "config.h"
#include "mod.h"
#include "mod_aspect_ratio.h"

int
aspect_ratio_init(void)
{
	if (!config.aspect_ratio)
		return (MOD_INIT_IGNORE);
	return (MOD_INIT_DONE);
}

int
aspect_ratio_keypressed(const int *keys, int keys_num, int *key_out)
{
	if (keys[0] != config.aspect_ratio)
		return (MOD_KEYPRESSED_UNKNOWN);
	*key_out = KEY_ASPECT;
	LOG("Replace key[0x%X] by ASPECT[0x%X]", keys[0], *key_out);
	return (MOD_KEYPRESSED_PROCESSED);
}
