#include "config.h"
#include "mod.h"
#include "mod_default_source.h"

int
default_source_init(void)
{
	if (!config.default_source)
		return (MOD_INIT_IGNORE);
	return (MOD_INIT_DONE);
}

int
default_source_keypressed(const int *keys, int keys_num, int *key_out)
{
	if (keys[0] != KEY_SOURCE)
		return (MOD_KEYPRESSED_UNKNOWN);
	
	if (keys[1] == config.default_source || keys[1] == KEY_SOURCE)
		return (MOD_KEYPRESSED_UNKNOWN);

	*key_out = config.default_source;
	LOG("Set default source[%d]", *key_out);
	return (MOD_KEYPRESSED_PROCESSED);
}
